package me.batizhao.jms.queue;

import org.apache.activemq.ActiveMQConnectionFactory;

import javax.jms.*;

/**
 * 这是一个最简单的基于文本消息的接收示例.
 * @author: batizhao
 * @since: 11-11-17 下午4:30
 */
public class QueueTextConsumer implements MessageListener {

    public static final String brokerURL = "tcp://localhost:61616";
    public static final String queueName = "jms.queue.text";

    public static void main(String[] args) throws JMSException{
        QueueTextConsumer consumer = new QueueTextConsumer();
        consumer.run();
    }

    public void run() throws JMSException {

        ConnectionFactory factory = new ActiveMQConnectionFactory(brokerURL);
        Connection connection = factory.createConnection();
        connection.start();
        Session session = connection.createSession(false, Session.AUTO_ACKNOWLEDGE);
        Destination destination = session.createQueue(queueName);
        MessageConsumer consumer = session.createConsumer(destination);
        consumer.setMessageListener(this);

    }

    public void onMessage(Message message) {
        try {
            if (message instanceof TextMessage) {
                TextMessage txtMessage = (TextMessage) message;
                System.out.println("Message received: " + txtMessage.getText());
            } else {
                System.out.println("Invalid message received.");
            }
        } catch (JMSException e) {
            System.out.println("Caught:" + e);
            e.printStackTrace();
        }
    }
}
